Index: examples/Validation.cpp
===================================================================
--- examples/Validation.cpp	(revision 87ff5a0d5ba9c8c4cc9eedbcb708eb9ac2813385)
+++ examples/Validation.cpp	(revision 92237ca859b003026b5fcdec8e41b9088fdb5736)
@@ -545,156 +1210,33 @@
 
 
-std::pair<Double_t, Double_t> GausFit(TH1* hist)
+
+//------------------------------------------------------------------------------
+
+
+void addResoGraph(TMultiGraph *mg, TGraphErrors *gr, TLegend *leg, int style, Color_t color, TString text)
 {
-  TF1 *f1 = new TF1("f1", "gaus", hist->GetMean()-2*hist->GetRMS(), hist->GetMean()+2*hist->GetRMS());
-  hist->Fit("f1","RQ");
-
-  TF1 *f2 = new TF1("f2", "gaus", f1->GetParameter(1) - 2*f1->GetParameter(2), f1->GetParameter(1) + 2*f1->GetParameter(2));
-  hist->Fit("f2","RQ");
-
-  Double_t sig = f2->GetParameter(2);
-  Double_t sigErr = f2->GetParError(2);
-
-  delete f1;
-  delete f2;
-  return make_pair (sig, sigErr);
+
+  gr->SetLineWidth(2);
+  gr->SetLineColor(color);
+  gr->SetMarkerStyle(style);
+  gr->SetMarkerColor(color);
+  gr->SetMarkerSize(1.5);
+
+  std::cout << "Adding " << gr->GetName() << std::endl;
+  mg->Add(gr);
+  leg->AddEntry(gr,text,"p");
+
 }
 
 
-TGraphErrors EresGraph(std::vector<resolPlot> *histos, bool central, bool rms = false)
+void DrawAxis(TMultiGraph *mg, TLegend *leg, double xmin, double xmax, double ymin, double ymax, TString tx, TString ty, bool logx = 0, bool logy = 0)
 {
-  Int_t bin;
-  Int_t count = 0;
-  TGraphErrors gr = TGraphErrors(Nbins/2);
-  Double_t sig = 0;
-  Double_t sigErr = 0;
-  for (bin = 0; bin < Nbins; bin++)
-  {
-    if (central == true && histos->at(bin).cenResolHist->GetEntries() > 100)
-    {
-      std::pair<Double_t, Double_t> sigvalues = GausFit(histos->at(bin).cenResolHist);
-      if (rms == true)
-      {
-        gr.SetPoint(count,(histos->at(bin).ptmin+histos->at(bin).ptmax)/2.0, sigvalues.second);
-        gr.SetPointError(count,0, sigvalues.second); // to correct
-      }
-      else
-      {
-        gr.SetPoint(count,(histos->at(bin).ptmin+histos->at(bin).ptmax)/2.0, sigvalues.first);
-        gr.SetPointError(count,0, sigvalues.second);
-      }
-      count++;
-    }
-
-    else if (central == false && histos->at(bin).fwdResolHist->GetEntries() > 10)
-    {
-      std::pair<Double_t, Double_t> sigvalues = GausFit(histos->at(bin).fwdResolHist);
-      if (rms == true)
-      {
-        gr.SetPoint(count,(histos->at(bin).ptmin+histos->at(bin).ptmax)/2.0, sigvalues.second);
-        gr.SetPointError(count,0, sigvalues.second); // to correct
-      }
-      else
-      {
-        gr.SetPoint(count,(histos->at(bin).ptmin+histos->at(bin).ptmax)/2.0, sigvalues.first);
-        gr.SetPointError(count,0, sigvalues.second);
-      }
-      count++;
-    }
-
-  }
-  return gr;
-}
-
-
-//------------------------------------------------------------------------------
-
-
-// type 1 : object, 2 : track, 3 : tower
-
-void addGraph(TMultiGraph *mg, TGraphErrors *gr, TLegend *leg, int type)
-{
-
-  gr->SetLineWidth(2);
-
-  switch ( type )
-  {
-    case 1:
-      gr->SetLineColor(objColor);
-      gr->SetLineStyle(objStyle);
-      std::cout << "Adding " << gr->GetName() << std::endl;
-      mg->Add(gr);
-      leg->AddEntry(gr,"Reco","l");
-      break;
-
-    case 2:
-      gr->SetLineColor(trackColor);
-      gr->SetLineStyle(trackStyle);
-      mg->Add(gr);
-      leg->AddEntry(gr,"Track","l");
-      break;
-
-    case 3:
-      gr->SetLineColor(towerColor);
-      gr->SetLineStyle(towerStyle);
-      mg->Add(gr);
-      leg->AddEntry(gr,"Tower","l");
-      break;
-
-    case 0:
-      gr->SetLineColor(objColor);
-      gr->SetLineStyle(objStyle);
-      mg->Add(gr);
-      break;
-
-    default:
-      std::cout << "wrong type, possibles choices are Object, Track and Tower" << std::endl;
-      break;
-  }
-}
-
-void addHist(TH1D *h, TLegend *leg, int type)
-{
-  h->SetLineWidth(2);
-
-  switch ( type )
-  {
-    case 1:
-      h->SetLineColor(objColor);
-      h->SetLineStyle(objStyle);
-      leg->AddEntry(h,"Reco","l");
-      break;
-
-    case 2:
-      h->SetLineColor(trackColor);
-      h->SetLineStyle(trackStyle);
-      leg->AddEntry(h,"Track","l");
-      break;
-
-    case 3:
-      h->SetLineColor(towerColor);
-      h->SetLineStyle(towerStyle);
-      leg->AddEntry(h,"Tower","l");
-      break;
-
-    case 0:
-      h->SetLineColor(objColor);
-      h->SetLineStyle(objStyle);
-      break;
-
-    default:
-      std::cout << "wrong type, possibles choices are Object, Track and Tower" << std::endl;
-      break;
-  }
-}
-
-void DrawAxis(TMultiGraph *mg, TLegend *leg, double max, int type = 0)
-{
-  mg->SetMinimum(0.);
-  mg->SetMaximum(max);
-  mg->GetXaxis()->SetLimits(ptrangemin,ptrangemax);
-  mg->GetYaxis()->SetTitle("resolution");
-  if (type == 0) mg->GetXaxis()->SetTitle("E [GeV]");
-  else mg->GetXaxis()->SetTitle("p_{T} [GeV]");
+  mg->SetMinimum(ymin);
+  mg->SetMaximum(ymax);
+  mg->GetXaxis()->SetLimits(xmin,xmax);
+
+  mg->GetXaxis()->SetTitle(tx);
+  mg->GetYaxis()->SetTitle(ty);
+
   mg->GetYaxis()->SetTitleSize(0.07);
   mg->GetXaxis()->SetTitleSize(0.07);
@@ -705,6 +1247,12 @@
   mg->GetXaxis()->SetTitleOffset(1.4);
 
+  mg->GetXaxis()->SetTitleFont(132);
+  mg->GetYaxis()->SetTitleFont(132);
+  mg->GetXaxis()->SetLabelFont(132);
+  mg->GetYaxis()->SetLabelFont(132);
+
   mg->GetYaxis()->SetNdivisions(505);
 
+  leg->SetTextFont(132);
   leg->SetBorderSize(0);
   leg->SetShadowColor(0);
@@ -713,5 +1261,10 @@
 
   gStyle->SetOptTitle(0);
-  gPad->SetLogx();
+
+  if(logx) gPad->SetLogx();
+  if(logy) gPad->SetLogy();
+
+  //gPad->SetGridx();
+  //gPad->SetGridy();
   gPad->SetBottomMargin(0.2);
   gPad->SetLeftMargin(0.2);
@@ -721,39 +1274,12 @@
 }
 
-void DrawAxis(TH1D *h, TLegend *leg, int type = 0)
+
+void Validation(const char *inputFilePion, const char *inputFileElectron, const char *inputFileMuon, const char *inputFilePhoton, const char *inputFileNeutralHadron, const char *inputFileJet, const char *inputFileBJet, const char *inputFileCJet, const char *inputFileTauJet, const char *outputFile)
 {
 
-  h->GetYaxis()->SetRangeUser(0,1.0);
-  if (type == 0) h->GetXaxis()->SetTitle("E [GeV]");
-  else h->GetXaxis()->SetTitle("p_{T} [GeV]");
-  h->GetYaxis()->SetTitle("efficiency");
-  h->GetYaxis()->SetTitleSize(0.07);
-  h->GetXaxis()->SetTitleSize(0.07);
-  h->GetYaxis()->SetLabelSize(0.06);
-  h->GetXaxis()->SetLabelSize(0.06);
-  h->GetYaxis()->SetLabelOffset(0.03);
-  h->GetYaxis()->SetTitleOffset(1.3);
-  h->GetXaxis()->SetTitleOffset(1.4);
-
-  h->GetYaxis()->SetNdivisions(505);
-
-  leg->SetBorderSize(0);
-  leg->SetShadowColor(0);
-  leg->SetFillColor(0);
-  leg->SetFillStyle(0);
-
-  gStyle->SetOptTitle(0);
-  gStyle->SetOptStat(0);
-  gPad->SetBottomMargin(0.2);
-  gPad->SetLeftMargin(0.2);
-
-  gPad->Modified();
-  gPad->Update();
-
-}
-
-
-void Validation(const char *inputFileElectron, const char *inputFileMuon, const char *inputFilePhoton, const char *inputFileJet, const char *inputFileBJet, const char *inputFileTauJet, const char *outputFile)
-{
+  TChain *chainPion = new TChain("Delphes");
+  chainPion->Add(inputFilePion);
+  ExRootTreeReader *treeReaderPion = new ExRootTreeReader(chainPion);
+
   TChain *chainElectron = new TChain("Delphes");
   chainElectron->Add(inputFileElectron);
@@ -768,4 +1294,8 @@
   ExRootTreeReader *treeReaderPhoton = new ExRootTreeReader(chainPhoton);
 
+  TChain *chainNeutralHadron = new TChain("Delphes");
+  chainNeutralHadron->Add(inputFileNeutralHadron);
+  ExRootTreeReader *treeReaderNeutralHadron = new ExRootTreeReader(chainNeutralHadron);
+
   TChain *chainJet = new TChain("Delphes");
   chainJet->Add(inputFileJet);
@@ -776,4 +1306,8 @@
   ExRootTreeReader *treeReaderBJet = new ExRootTreeReader(chainBJet);
 
+  TChain *chainCJet = new TChain("Delphes");
+  chainCJet->Add(inputFileCJet);
+  ExRootTreeReader *treeReaderCJet = new ExRootTreeReader(chainCJet);
+
   TChain *chainTauJet = new TChain("Delphes");
   chainTauJet->Add(inputFileTauJet);
@@ -782,5 +1316,4 @@
   TClonesArray *branchParticleElectron = treeReaderElectron->UseBranch("Particle");
   TClonesArray *branchTrackElectron = treeReaderElectron->UseBranch("Track");
-  TClonesArray *branchTowerElectron = treeReaderElectron->UseBranch("Tower");
   TClonesArray *branchElectron = treeReaderElectron->UseBranch("Electron");
 
@@ -789,9 +1322,17 @@
   TClonesArray *branchMuon = treeReaderMuon->UseBranch("Muon");
 
+  TClonesArray *branchParticlePion = treeReaderPion->UseBranch("Particle");
+  TClonesArray *branchTrackPion = treeReaderPion->UseBranch("Track");
+  TClonesArray *branchPion = treeReaderPion->UseBranch("Pion");
+
   TClonesArray *branchParticlePhoton = treeReaderPhoton->UseBranch("Particle");
   TClonesArray *branchTowerPhoton = treeReaderPhoton->UseBranch("Tower");
   TClonesArray *branchPhoton = treeReaderPhoton->UseBranch("Photon");
 
+  TClonesArray *branchParticleNeutralHadron = treeReaderNeutralHadron->UseBranch("Particle");
+  TClonesArray *branchTowerNeutralHadron = treeReaderNeutralHadron->UseBranch("Tower");
+
   TClonesArray *branchGenJet = treeReaderJet->UseBranch("GenJet");
+  TClonesArray *branchParticleJet = treeReaderJet->UseBranch("Particle");
   TClonesArray *branchPFJet = treeReaderJet->UseBranch("Jet");
   TClonesArray *branchCaloJet = treeReaderJet->UseBranch("CaloJet");
